program TVEdit;
uses Drivers,Objects, Memory, Views, Menus, Dialogs,
  StdDlg, MsgBox, App, Editors;
type
  TEditorApp = object(TApplication)
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitMenuBar; virtual;
  end;

var
  EditorApp: TEditorApp;

function OpenEditor(FileName: String; Visible: Boolean): PEditWindow;
var
  P: PWindow;
  R: TRect;
begin
  DeskTop^.GetExtent(R);
  R.Assign(1,1,10,10);
  P := New(PEditWindow, Init(R, FileName, wnNoNumber));
  if not Visible then P^.Hide;
  Result := PEditWindow(Application^.InsertWindow(P));
end;

procedure TEditorApp.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
        cmNew:   OpenEditor('', True);
      else
        Exit;
      end;
  else
    Exit;
  end;
  ClearEvent(Event);
end;

procedure TEditorApp.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
    NewItem('~N~eu xxxxxx', '', kbF4, cmNew, hcNoContext,
      nil)),
    NewSubMenu('~W~indows', hcNoContext, NewMenu(
    NewItem('~c~ascade xxxxxx', '', kbNoKey, cmCascade, hcNoContext,
    NewItem('~t~ile xxxxxxxxx', '', kbNoKey, cmTile, hcNoContext,
      nil))),
    nil)))));
end;

begin
  EditorApp.Init;
  EditorApp.Run;
  EditorApp.Done;
end.
